#include<avr/io.h>
#include <util/delay.h>

#include <stdlib.h> 
#include <stdio.h>
#include <string.h>

#define uint unsigned int
#define uchar unsigned char

#include "Nokia5110/Nokia5110.h"
#include "DS1037/rtc.h"

struct Angajat {
   char id[11];
   char nume[20];
   char prenume[20];
   char ora[9];
};

int GetIndexEmployee(struct Angajat angajati[], char id[]) {
    int i;
    for(i = 0; i < 2; i++){
        if(strcmp(id, angajati[i].id) == 0){
            return i;
        }
    }
    
    return 0;
}

long GetTotalSeconds(char Hour[]){
    	char *Time = strtok(Hour, ":");
    	int hour = atoi(Time);
	    
	Time = strtok(NULL, ":");
	int minute = atoi(Time);
	    
	Time = strtok(NULL, ":");
	int second = atoi(Time);
	
	return (hour * 60L + minute) * 60L + second;
}

const char *SecondsToHours(long seconds) {
    
    long hour = seconds/3600;
    seconds = seconds %3600;
    
    long minute = seconds/60;
    seconds = seconds % 60;
    
    static char text[15];
    sprintf( text, "%ld:%ld:%ld", hour, minute, seconds);
    printf("%s\n", text);
	
    return text;
}

int main(void) 
{
	char Fisier[150] = "00000000 Bruce Wayne 08:01:02 00000001 Tonny Stark 14:00:00 00000002 Sonya Blade 11:00:00 00000003 Barry Allen 13:00:00";
	char id[11] = "00000003";
	int i = 0, NrAngajati = 0;
	struct Angajat angajati[4];
	char text[15];
	rtc_t rtc;

	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB2);

	char *ptr = strtok(Fisier, " ");
	while(ptr != NULL)
	{
		strcpy(angajati[NrAngajati].id, ptr);
		
		ptr = strtok(NULL, " ");
		strcpy(angajati[NrAngajati].nume, ptr);
		
		ptr = strtok(NULL, " ");
		strcpy(angajati[NrAngajati].prenume, ptr);
		
		ptr = strtok(NULL, " ");
		strcpy(angajati[NrAngajati].ora, ptr);
		
		ptr = strtok(NULL, " ");
		NrAngajati++;
	}

	LCD_init();       //LCD initialization
	LCD_clear();      //clear the LCD
	

	/*Connect SCL->PC0, SDA->PC1*/    
    	RTC_Init();

    	rtc.hour = 0x11; //  11:40:20 am
    	rtc.min =  0x40;
    	rtc.sec =  0x20;

    	rtc.date = 0x24;
    	rtc.month = 0x05;
    	rtc.year = 0x19;
	rtc.weekDay = 5; // Friday: 5th day of week considering monday as first day.

	RTC_SetDateTime(&rtc);  //  11:40:20 am, 24th May 2019

    	/* Display the Time and Date continuously */
   	while(1)
    	{
		RTC_GetDateTime(&rtc);

		sprintf( text, "Time: %2x:%2x:%2x", (uint16_t)rtc.hour, (uint16_t)rtc.min, (uint16_t)rtc.sec);
		LCD_write_string(0,0,text);
		sprintf( text, "Date: %2x/%2x/%2x", (uint16_t)rtc.date, (uint16_t)rtc.month, (uint16_t)rtc.year);
		LCD_write_string(0,1,text);

		//i = GetIndexEmployee(angajati, id);
		if((PINB & (1 << PB2)) == 0){
			i++;
			if(i == NrAngajati){
				i = 0;
			}
		}

		char CurrentTime[10];
		sprintf( CurrentTime, "%2x:%2x:%2x", (uint16_t)rtc.hour, (uint16_t)rtc.min, (uint16_t)rtc.sec);

		long NrSecondsAngajat = GetTotalSeconds(angajati[i].ora);
		long NrSecondsCurrent = GetTotalSeconds(CurrentTime);
		
		char MesajAngajat[15] = "              ";
		char Intarziere[15] = "              ";
		sprintf( MesajAngajat, "%s %s", angajati[i].nume, angajati[i].prenume);
		LCD_write_string(0,2,MesajAngajat);

		if(NrSecondsAngajat < NrSecondsCurrent){

			sprintf( Intarziere, "%s later", SecondsToHours(NrSecondsCurrent - NrSecondsAngajat));
			LCD_write_string(0,3, Intarziere);
			DDRB |= 1 << PB4;
			_delay_us(1000);
			DDRB &= ~(1 << PB4);
		}else{
			sprintf( Intarziere, "%s", "Welcome       ");
			LCD_write_string(0,3, Intarziere);
		}
	}

	return 0;
}



